#include "Fl_Smart_Choice.h"
#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <stdio.h>  // debug only

/******************************************************************************/

Fl_Smart_Choice::Fl_Smart_Choice(int X, int Y, int W, int H, const char *L) : Fl_Choice(X, Y, W, H, L)
{
}

/******************************************************************************/

Fl_Smart_Choice::~Fl_Smart_Choice()
{
}

/******************************************************************************/

const Fl_Menu_Item* Fl_Smart_Choice::picked(const Fl_Menu_Item *v)
{
	if(v && v->text)
	{
		fl_font(textfont(), textsize());

		int tw = 0;
		int th = 0;

		fl_measure(v->text, tw, th, 1);

		int ww = w() - Fl::box_dw(box()) - (h() > 20 ? 20 : h());

		if(tw > ww)			// item's text is longer than we are wide
			tooltip(v->text);
		else				// item's text fits nicely in our width
			tooltip(0);

		printf("text=%s tw=%d ww=%d tooltip=%s\n", text(), tw, ww, tooltip());
	}

	return Fl_Choice::picked(v);
}

/******************************************************************************/
